export interface JQueryPromiseCallback<T> {
    (value?: T, ...args: any[]): void;
}
export interface JQueryGenericPromise<T> {
    then<U>(doneFilter: (value: T) => U, failFilter?: (reason: any) => U): JQueryGenericPromise<U>;
    then<U>(doneFilter: (value: T) => JQueryGenericPromise<U>, failFilter?: (reason: any) => U): JQueryGenericPromise<U>;
    then<U>(doneFilter: (value: T) => U, failFilter?: (reason: any) => JQueryGenericPromise<U>): JQueryGenericPromise<U>;
    then<U>(doneFilter: (value: T) => JQueryGenericPromise<U>, failFilter?: (reason: any) => JQueryGenericPromise<U>): JQueryGenericPromise<U>;
}
export interface JQueryPromise<T> {
    always(...alwaysCallbacks: JQueryPromiseCallback<T>[]): JQueryDeferred<T>;
    done(...doneCallbacks: JQueryPromiseCallback<T>[]): JQueryDeferred<T>;
    fail(...failCallbacks: JQueryPromiseCallback<any>[]): JQueryDeferred<T>;
    progress(...progressCallbacks: JQueryPromiseCallback<T>[]): JQueryDeferred<T>;
    pipe<U>(doneFilter: (value: T) => JQueryGenericPromise<U>, failFilter?: (...reasons: any[]) => U, progressFilter?: (...progression: any[]) => any): JQueryPromise<U>;
    then<U>(doneFilter: (value: T) => U, failFilter?: (...reasons: any[]) => U, progressFilter?: (...progression: any[]) => any): JQueryPromise<U>;
    then<U>(doneFilter: (value: T) => JQueryGenericPromise<U>, failFilter?: (...reasons: any[]) => U, progressFilter?: (...progression: any[]) => any): JQueryPromise<U>;
    then<U>(doneFilter: (value: T) => U, failFilter?: (...reasons: any[]) => JQueryGenericPromise<U>, progressFilter?: (...progression: any[]) => any): JQueryPromise<U>;
    then<U>(doneFilter: (value: T) => JQueryGenericPromise<U>, failFilter?: (...reasons: any[]) => JQueryGenericPromise<U>, progressFilter?: (...progression: any[]) => any): JQueryPromise<U>;
    then<U>(doneFilter: (...values: any[]) => U, failFilter?: (...reasons: any[]) => U, progressFilter?: (...progression: any[]) => any): JQueryPromise<U>;
    then<U>(doneFilter: (...values: any[]) => JQueryGenericPromise<U>, failFilter?: (...reasons: any[]) => U, progressFilter?: (...progression: any[]) => any): JQueryPromise<U>;
    then<U>(doneFilter: (...values: any[]) => U, failFilter?: (...reasons: any[]) => JQueryGenericPromise<U>, progressFilter?: (...progression: any[]) => any): JQueryPromise<U>;
    then<U>(doneFilter: (...values: any[]) => JQueryGenericPromise<U>, failFilter?: (...reasons: any[]) => JQueryGenericPromise<U>, progressFilter?: (...progression: any[]) => any): JQueryPromise<U>;
}
export interface JQueryDeferred<T> extends JQueryPromise<T> {
    always(...alwaysCallbacks: JQueryPromiseCallback<T>[]): JQueryDeferred<T>;
    done(...doneCallbacks: JQueryPromiseCallback<T>[]): JQueryDeferred<T>;
    fail(...failCallbacks: JQueryPromiseCallback<any>[]): JQueryDeferred<T>;
    progress(...progressCallbacks: JQueryPromiseCallback<T>[]): JQueryDeferred<T>;
    notify(...args: any[]): JQueryDeferred<T>;
    reject(...args: any[]): JQueryDeferred<T>;
    resolve(value?: T, ...args: any[]): JQueryDeferred<T>;
    state(): string;
    promise(target?: any): JQueryPromise<T>;
}
export interface JQueryStatic {
    Deferred: new<T>(beforeStart?: (deferred: JQueryDeferred<T>) => any) => JQueryDeferred<T>;
    when: (...promises: JQueryPromise<any>[]) => JQueryPromise<any>;
}
export declare var jQuery: JQueryStatic;
export declare var $: JQueryStatic;
