var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var Q = require("q");






var JQueryPromiseAdapter = (function () {
    function JQueryPromiseAdapter(_promise) {
        this._promise = _promise;
    }
    JQueryPromiseAdapter._wrap = function (callback) {
        return function () {
            var args = [];
            for (var _i = 0; _i < (arguments.length - 0); _i++) {
                args[_i] = arguments[_i + 0];
            }
            var result = callback.apply(this, args);
            if (result instanceof JQueryPromiseAdapter || result instanceof JQueryDeferredAdapter) {
                result = result._promise;
            }
            return result;
        };
    };

    JQueryPromiseAdapter.prototype.always = function () {
        var alwaysCallbacks = [];
        for (var _i = 0; _i < (arguments.length - 0); _i++) {
            alwaysCallbacks[_i] = arguments[_i + 0];
        }
        var result = this._promise;
        if (alwaysCallbacks) {
            for (var i in alwaysCallbacks) {
                var callback = alwaysCallbacks[i];
                result = result.finally(JQueryPromiseAdapter._wrap(callback));
            }
        }

        return (new JQueryPromiseAdapter(result));
    };

    JQueryPromiseAdapter.prototype.done = function () {
        var doneCallbacks = [];
        for (var _i = 0; _i < (arguments.length - 0); _i++) {
            doneCallbacks[_i] = arguments[_i + 0];
        }
        if (doneCallbacks) {
            for (var i in doneCallbacks) {
                var callback = doneCallbacks[i];
                this._promise.done(JQueryPromiseAdapter._wrap(callback));
            }
        }

        return this;
    };

    JQueryPromiseAdapter.prototype.fail = function () {
        var failCallbacks = [];
        for (var _i = 0; _i < (arguments.length - 0); _i++) {
            failCallbacks[_i] = arguments[_i + 0];
        }
        var result = this._promise;
        if (failCallbacks) {
            for (var i in failCallbacks) {
                var callback = failCallbacks[i];
                result = result.catch(JQueryPromiseAdapter._wrap(callback));
            }
        }

        return (new JQueryPromiseAdapter(result));
    };

    JQueryPromiseAdapter.prototype.progress = function () {
        var progressCallbacks = [];
        for (var _i = 0; _i < (arguments.length - 0); _i++) {
            progressCallbacks[_i] = arguments[_i + 0];
        }
        var result = this._promise;
        if (progressCallbacks) {
            for (var i in progressCallbacks) {
                var callback = progressCallbacks[i];
                result = result.progress(JQueryPromiseAdapter._wrap(callback));
            }
        }

        return (new JQueryPromiseAdapter(result));
    };

    JQueryPromiseAdapter.prototype.pipe = function (doneFilter, failFilter, progressFilter) {
        return this.then(doneFilter, failFilter, progressFilter);
    };

    JQueryPromiseAdapter.prototype.then = function (doneFilter, failFilter, progressFilter) {
        var result = this._promise.then(JQueryPromiseAdapter._wrap(doneFilter), JQueryPromiseAdapter._wrap(failFilter), JQueryPromiseAdapter._wrap(progressFilter));
        return new JQueryPromiseAdapter(result);
    };
    return JQueryPromiseAdapter;
})();

var JQueryDeferredAdapter = (function (_super) {
    __extends(JQueryDeferredAdapter, _super);
    function JQueryDeferredAdapter(beforeStart, _deferred) {
        _super.call(this);
        this._deferred = _deferred;
        if (beforeStart) {
            beforeStart(this);
        }
        if (this._deferred == null) {
            this._deferred = Q.defer();
        }
        this._promise = this._deferred.promise;
    }
    JQueryDeferredAdapter.prototype.notify = function () {
        var args = [];
        for (var _i = 0; _i < (arguments.length - 0); _i++) {
            args[_i] = arguments[_i + 0];
        }
        var result = this._deferred.notify.apply(this._deferred, args);
        return new JQueryDeferredAdapter(result);
    };

    JQueryDeferredAdapter.prototype.reject = function () {
        var args = [];
        for (var _i = 0; _i < (arguments.length - 0); _i++) {
            args[_i] = arguments[_i + 0];
        }
        var result = this._deferred.reject.apply(this._deferred, args);
        return new JQueryDeferredAdapter(result);
    };

    JQueryDeferredAdapter.prototype.resolve = function (value) {
        var args = [];
        for (var _i = 0; _i < (arguments.length - 1); _i++) {
            args[_i] = arguments[_i + 1];
        }
        var result = this._deferred.resolve.apply(this._deferred, args);
        return new JQueryDeferredAdapter(result);
    };

    JQueryDeferredAdapter.prototype.state = function () {
        return this._promise.inspect().state;
    };

    JQueryDeferredAdapter.prototype.promise = function (target) {
        return new JQueryPromiseAdapter(this._promise);
    };
    return JQueryDeferredAdapter;
})(JQueryPromiseAdapter);

exports.jQuery = {
    Deferred: JQueryDeferredAdapter,
    when: function () {
        var promises = [];
        for (var _i = 0; _i < (arguments.length - 0); _i++) {
            promises[_i] = arguments[_i + 0];
        }
        var qPromises = [];
        for (var i in promises) {
            var promise = promises[i];
            qPromises.push(promise._promise);
        }
        var result = Q.all(qPromises);
        return new JQueryPromiseAdapter(result);
    }
};
exports.$ = exports.jQuery;
